package servletsocket;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.net.*;

public class ServletSocket extends HttpServlet {
  //Traiter la requte HTTP Post
  public void doPost(HttpServletRequest request, HttpServletResponse response)
      throws ServletException, IOException {
    try {
      ObjectInputStream requte = new ObjectInputStream(request.getInputStream());
      Transmission transmission = (Transmission) requte.readObject();
      int numroPort = transmission.getPort();
      try {
        Socket connexion = new Socket("localhost", numroPort);
        PrintWriter requteInversion = new PrintWriter(connexion.getOutputStream(), true);
        requteInversion.println(transmission.getMessage());
        BufferedReader rceptionInversion = new BufferedReader(new InputStreamReader(connexion.getInputStream()));
        transmission = new Transmission(numroPort, rceptionInversion.readLine(), true);
      }
      catch (IOException erreur) {
        transmission = new Transmission(numroPort, erreur.getMessage(), false);
      }
      ObjectOutputStream rponse = new ObjectOutputStream(response.getOutputStream());
      rponse.writeObject(transmission);
    }
    catch (IOException erreur) { System.err.println("Erreur communication applet"); }
    catch (ClassNotFoundException erreur) { System.err.println("Objet non transmis"); }
  }
}
